1#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9#     http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
20args="$@"
21while [ -h "${prog}" ]; do
22    newProg=`/bin/ls -ld "${prog}"`
23    newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24    if expr "x${newProg}" : 'x/' >/dev/null; then
25        prog="${newProg}"
26    else
27        progdir=`dirname "${prog}"`
28        prog="${progdir}/${newProg}"
29    fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
36test_dir="test-$$"
37if [ -z "$TMPDIR" ]; then
38  tmp_dir="/tmp/$USER/${test_dir}"
39else
40  tmp_dir="${TMPDIR}/${test_dir}"
41fi
42checker="${progdir}/../tools/checker/checker.py"
43export JAVA="java"
44export JAVAC="javac -g -Xlint:-options"
45export RUN="${progdir}/etc/run-test-jar"
46export DEX_LOCATION=/data/run-test/${test_dir}
47export NEED_DEX="true"
48export USE_JACK="true"
49export SMALI_ARGS="--experimental"
50
51# If dx was not set by the environment variable, assume it is in the path.
52if [ -z "$DX" ]; then
53  export DX="dx"
54fi
55
56# If jasmin was not set by the environment variable, assume it is in the path.
57if [ -z "$JASMIN" ]; then
58  export JASMIN="jasmin"
59fi
60
61# If smali was not set by the environment variable, assume it is in the path.
62if [ -z "$SMALI" ]; then
63  export SMALI="smali"
64fi
65
66# If dexmerger was not set by the environment variable, assume it is in the path.
67if [ -z "$DXMERGER" ]; then
68  export DXMERGER="dexmerger"
69fi
70
71# If jack was not set by the environment variable, assume it is in the path.
72if [ -z "$JACK" ]; then
73  export JACK="jack"
74fi
75
76# ANDROID_BUILD_TOP is not set in a build environment.
77if [ -z "$ANDROID_BUILD_TOP" ]; then
78    export ANDROID_BUILD_TOP=$oldwd
79fi
80
81# ANDROID_HOST_OUT is not set in a build environment.
82if [ -z "$ANDROID_HOST_OUT" ]; then
83    export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out}/host/linux-x86
84fi
85
86# If JACK_CLASSPATH is not set, assume it only contains core-libart.
87if [ -z "$JACK_CLASSPATH" ]; then
88  export JACK_CLASSPATH="${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack"
89fi
90
91export JACK="$JACK -g -cp $JACK_CLASSPATH"
92
93# Zipalign is not on the PATH in some configs, auto-detect it.
94if [ -z "$ZIPALIGN" ]; then
95  if which zipalign >/dev/null; then
96    ZIPALIGN="zipalign";
97  else
98    # TODO: Add a dependency for zipalign in Android.run-test.mk
99    # once it doesn't depend on libandroidfw (b/35246701)
100    case "$OSTYPE" in
101      darwin*)  ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;;
102      linux*)   ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;;
103      *)        echo "Can't find zipalign: unknown: $OSTYPE" >&2;;
104    esac
105  fi
106fi
107export ZIPALIGN
108
109info="info.txt"
110build="build"
111run="run"
112expected="expected.txt"
113check_cmd="check"
114output="output.txt"
115build_output="build-output.txt"
116cfg_output="graph.cfg"
117strace_output="strace-output.txt"
118lib="libartd.so"
119testlib="arttestd"
120run_args="--quiet"
121build_args=""
122
123quiet="no"
124debuggable="no"
125prebuild_mode="yes"
126target_mode="yes"
127dev_mode="no"
128update_mode="no"
129debug_mode="no"
130relocate="no"
131runtime="art"
132usage="no"
133build_only="no"
134suffix64=""
135trace="false"
136trace_stream="false"
137basic_verify="false"
138gc_verify="false"
139gc_stress="false"
140jvmti_stress="false"
141strace="false"
142always_clean="no"
143never_clean="no"
144have_dex2oat="yes"
145have_patchoat="yes"
146have_image="yes"
147multi_image_suffix=""
148android_root="/system"
149bisection_search="no"
150suspend_timeout="500000"
151# By default we will use optimizing.
152image_args=""
153image_suffix=""
154
155while true; do
156    if [ "x$1" = "x--host" ]; then
157        target_mode="no"
158        DEX_LOCATION=$tmp_dir
159        run_args="${run_args} --host"
160        shift
161    elif [ "x$1" = "x--quiet" ]; then
162        quiet="yes"
163        shift
164    elif [ "x$1" = "x--use-java-home" ]; then
165        if [ -n "${JAVA_HOME}" ]; then
166          export JAVA="${JAVA_HOME}/bin/java"
167          export JAVAC="${JAVA_HOME}/bin/javac -g"
168        else
169          echo "Passed --use-java-home without JAVA_HOME variable set!"
170          usage="yes"
171        fi
172        shift
173    elif [ "x$1" = "x--jvm" ]; then
174        target_mode="no"
175        DEX_LOCATION="$tmp_dir"
176        runtime="jvm"
177        image_args=""
178        prebuild_mode="no"
179        NEED_DEX="false"
180        USE_JACK="false"
181        run_args="${run_args} --jvm"
182        build_args="${build_args} --jvm"
183        shift
184    elif [ "x$1" = "x-O" ]; then
185        lib="libart.so"
186        testlib="arttest"
187        run_args="${run_args} -O"
188        shift
189    elif [ "x$1" = "x--dalvik" ]; then
190        lib="libdvm.so"
191        runtime="dalvik"
192        shift
193    elif [ "x$1" = "x--no-dex2oat" ]; then
194        have_dex2oat="no"
195        shift
196    elif [ "x$1" = "x--no-patchoat" ]; then
197        have_patchoat="no"
198        shift
199    elif [ "x$1" = "x--no-image" ]; then
200        have_image="no"
201        shift
202    elif [ "x$1" = "x--multi-image" ]; then
203        multi_image_suffix="-multi"
204        shift
205    elif [ "x$1" = "x--pic-test" ]; then
206        run_args="${run_args} --pic-test"
207        shift
208    elif [ "x$1" = "x--relocate" ]; then
209        relocate="yes"
210        shift
211    elif [ "x$1" = "x--no-relocate" ]; then
212        relocate="no"
213        shift
214    elif [ "x$1" = "x--prebuild" ]; then
215        run_args="${run_args} --prebuild"
216        prebuild_mode="yes"
217        shift;
218    elif [ "x$1" = "x--strip-dex" ]; then
219        run_args="${run_args} --strip-dex"
220        shift;
221    elif [ "x$1" = "x--debuggable" ]; then
222        run_args="${run_args} -Xcompiler-option --debuggable"
223        debuggable="yes"
224        shift;
225    elif [ "x$1" = "x--no-prebuild" ]; then
226        run_args="${run_args} --no-prebuild"
227        prebuild_mode="no"
228        shift;
229    elif [ "x$1" = "x--gcverify" ]; then
230        basic_verify="true"
231        gc_verify="true"
232        shift
233    elif [ "x$1" = "x--gcstress" ]; then
234        basic_verify="true"
235        gc_stress="true"
236        shift
237    elif [ "x$1" = "x--jvmti-stress" ]; then
238        jvmti_stress="true"
239        shift
240    elif [ "x$1" = "x--suspend-timeout" ]; then
241        shift
242        suspend_timeout="$1"
243        shift
244    elif [ "x$1" = "x--image" ]; then
245        shift
246        image="$1"
247        run_args="${run_args} --image $image"
248        shift
249    elif [ "x$1" = "x-Xcompiler-option" ]; then
250        shift
251        option="$1"
252        run_args="${run_args} -Xcompiler-option $option"
253        shift
254    elif [ "x$1" = "x--build-option" ]; then
255        shift
256        option="$1"
257        build_args="${build_args} $option"
258        shift
259    elif [ "x$1" = "x--runtime-option" ]; then
260        shift
261        option="$1"
262        run_args="${run_args} --runtime-option $option"
263        shift
264    elif [ "x$1" = "x--gdb-arg" ]; then
265        shift
266        gdb_arg="$1"
267        run_args="${run_args} --gdb-arg $gdb_arg"
268        shift
269    elif [ "x$1" = "x--debug" ]; then
270        run_args="${run_args} --debug"
271        shift
272    elif [ "x$1" = "x--gdb" ]; then
273        run_args="${run_args} --gdb"
274        dev_mode="yes"
275        shift
276    elif [ "x$1" = "x--strace" ]; then
277        strace="yes"
278        run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output"
279        shift
280    elif [ "x$1" = "x--zygote" ]; then
281        run_args="${run_args} --zygote"
282        shift
283    elif [ "x$1" = "x--interpreter" ]; then
284        run_args="${run_args} --interpreter"
285        image_suffix="-interpreter"
286        shift
287    elif [ "x$1" = "x--jit" ]; then
288        image_args="--jit"
289        image_suffix="-interpreter"
290        shift
291    elif [ "x$1" = "x--optimizing" ]; then
292        image_args="-Xcompiler-option --compiler-backend=Optimizing"
293        shift
294    elif [ "x$1" = "x--no-verify" ]; then
295        run_args="${run_args} --no-verify"
296        shift
297    elif [ "x$1" = "x--verify-soft-fail" ]; then
298        image_args="--verify-soft-fail"
299        image_suffix="-interp-ac"
300        shift
301    elif [ "x$1" = "x--no-optimize" ]; then
302        run_args="${run_args} --no-optimize"
303        shift
304    elif [ "x$1" = "x--no-precise" ]; then
305        run_args="${run_args} --no-precise"
306        shift
307    elif [ "x$1" = "x--invoke-with" ]; then
308        shift
309        what="$1"
310        if [ "x$what" = "x" ]; then
311            echo "$0 missing argument to --invoke-with" 1>&2
312            usage="yes"
313            break
314        fi
315        run_args="${run_args} --invoke-with ${what}"
316        shift
317    elif [ "x$1" = "x--dev" ]; then
318        run_args="${run_args} --dev"
319        dev_mode="yes"
320        shift
321    elif [ "x$1" = "x--build-only" ]; then
322        build_only="yes"
323        shift
324    elif [ "x$1" = "x--build-with-javac-dx" ]; then
325        USE_JACK="false"
326        shift
327    elif [ "x$1" = "x--build-with-jack" ]; then
328        USE_JACK="true"
329        shift
330    elif [ "x$1" = "x--output-path" ]; then
331        shift
332        tmp_dir=$1
333        if [ "x$tmp_dir" = "x" ]; then
334            echo "$0 missing argument to --output-path" 1>&2
335            usage="yes"
336            break
337        fi
338        shift
339    elif [ "x$1" = "x--android-root" ]; then
340        shift
341        if [ "x$1" = "x" ]; then
342            echo "$0 missing argument to --android-root" 1>&2
343            usage="yes"
344            break
345        fi
346        android_root="$1"
347        run_args="${run_args} --android-root $1"
348        shift
349    elif [ "x$1" = "x--update" ]; then
350        update_mode="yes"
351        shift
352    elif [ "x$1" = "x--help" ]; then
353        usage="yes"
354        shift
355    elif [ "x$1" = "x--64" ]; then
356        run_args="${run_args} --64"
357        suffix64="64"
358        shift
359    elif [ "x$1" = "x--trace" ]; then
360        trace="true"
361        shift
362    elif [ "x$1" = "x--stream" ]; then
363        trace_stream="true"
364        shift
365    elif [ "x$1" = "x--always-clean" ]; then
366        always_clean="yes"
367        shift
368    elif [ "x$1" = "x--never-clean" ]; then
369        never_clean="yes"
370        shift
371    elif [ "x$1" = "x--dex2oat-swap" ]; then
372        run_args="${run_args} --dex2oat-swap"
373        shift
374    elif [ "x$1" = "x--instruction-set-features" ]; then
375        shift
376        run_args="${run_args} --instruction-set-features $1"
377        shift
378    elif [ "x$1" = "x--bisection-search" ]; then
379        bisection_search="yes"
380        shift
381    elif [ "x$1" = "x--vdex" ]; then
382        run_args="${run_args} --vdex"
383        shift
384    elif [ "x$1" = "x--vdex-filter" ]; then
385        shift
386        filter=$1
387        run_args="${run_args} --vdex-filter $filter"
388        shift
389    elif [ "x$1" = "x--random-profile" ]; then
390        run_args="${run_args} --random-profile"
391        shift
392    elif expr "x$1" : "x--" >/dev/null 2>&1; then
393        echo "unknown $0 option: $1" 1>&2
394        usage="yes"
395        break
396    else
397        break
398    fi
399done
400
401run_args="${run_args} ${image_args}"
402# Allocate file descriptor real_stderr and redirect it to the shell's error
403# output (fd 2).
404if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
405  exec {real_stderr}>&2
406else
407  # In bash before version 4.1 we need to do a manual search for free file
408  # descriptors.
409  FD=3
410  while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
411  real_stderr=$FD
412  eval "exec ${real_stderr}>&2"
413fi
414if [ "$quiet" = "yes" ]; then
415  # Force the default standard output and error to go to /dev/null so we will
416  # not print them.
417  exec 1>/dev/null
418  exec 2>/dev/null
419fi
420
421function err_echo() {
422  echo "$@" 1>&${real_stderr}
423}
424
425# tmp_dir may be relative, resolve.
426#
427# Cannot use realpath, as it does not exist on Mac.
428# Cannot us a simple "cd", as the path might not be created yet.
429# Cannot use readlink -m, as it does not exist on Mac.
430# Fallback to nuclear option:
431noncanonical_tmp_dir=$tmp_dir
432tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
433mkdir -p $tmp_dir
434
435# Add thread suspend timeout flag
436if [ ! "$runtime" = "jvm" ]; then
437  run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout"
438fi
439
440if [ "$basic_verify" = "true" ]; then
441  # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
442  run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
443fi
444if [ "$gc_verify" = "true" ]; then
445  run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
446fi
447if [ "$gc_stress" = "true" ]; then
448  run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m"
449fi
450if [ "$jvmti_stress" = "true" ]; then
451    run_args="${run_args} --no-app-image --jvmti-stress"
452fi
453if [ "$trace" = "true" ]; then
454    run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000"
455    if [ "$trace_stream" = "true" ]; then
456        # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
457        # the ability to analyze the file and just write to /dev/null.
458        run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null"
459        # Enable streaming mode.
460        run_args="${run_args} --runtime-option -Xmethod-trace-stream"
461    else
462        run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin"
463    fi
464elif [ "$trace_stream" = "true" ]; then
465    err_echo "Cannot use --stream without --trace."
466    exit 1
467fi
468
469# Most interesting target architecture variables are Makefile variables, not environment variables.
470# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
471function guess_target_arch_name() {
472    grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
473    grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
474    if [ "x${suffix64}" = "x64" ]; then
475        target_arch_name=${grep64bit}
476    else
477        target_arch_name=${grep32bit}
478    fi
479}
480
481function guess_host_arch_name() {
482    if [ "x${suffix64}" = "x64" ]; then
483        host_arch_name="x86_64"
484    else
485        host_arch_name="x86"
486    fi
487}
488
489if [ "$target_mode" = "no" ]; then
490    if [ "$runtime" = "jvm" ]; then
491        if [ "$prebuild_mode" = "yes" ]; then
492            err_echo "--prebuild with --jvm is unsupported"
493            exit 1;
494        fi
495    fi
496fi
497
498if [ "$have_patchoat" = "no" ]; then
499  run_args="${run_args} --no-patchoat"
500fi
501
502if [ "$have_dex2oat" = "no" ]; then
503  run_args="${run_args} --no-dex2oat"
504fi
505
506if [ ! "$runtime" = "jvm" ]; then
507  run_args="${run_args} --lib $lib"
508fi
509
510if [ "$runtime" = "dalvik" ]; then
511    if [ "$target_mode" = "no" ]; then
512        framework="${ANDROID_PRODUCT_OUT}/system/framework"
513        bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
514        run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}"
515    else
516        true # defaults to using target BOOTCLASSPATH
517    fi
518elif [ "$runtime" = "art" ]; then
519    if [ "$target_mode" = "no" ]; then
520        guess_host_arch_name
521        run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${multi_image_suffix}.art"
522        run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}"
523    else
524        guess_target_arch_name
525        run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}"
526        run_args="${run_args} --boot /data/art-test/core${image_suffix}${multi_image_suffix}.art"
527    fi
528    if [ "$relocate" = "yes" ]; then
529      run_args="${run_args} --relocate"
530    else
531      run_args="${run_args} --no-relocate"
532    fi
533elif [ "$runtime" = "jvm" ]; then
534    # TODO: Detect whether the host is 32-bit or 64-bit.
535    run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64"
536fi
537
538if [ "$have_image" = "no" ]; then
539    if [ "$runtime" != "art" ]; then
540        err_echo "--no-image is only supported on the art runtime"
541        exit 1
542    fi
543    run_args="${run_args} --no-image"
544fi
545
546if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
547    err_echo "--dev and --update are mutually exclusive"
548    usage="yes"
549fi
550
551if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
552    err_echo "--dev and --quiet are mutually exclusive"
553    usage="yes"
554fi
555
556if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then
557    err_echo "--bisection-search and --prebuild are mutually exclusive"
558    usage="yes"
559fi
560
561if [ "$bisection_search" = "yes" -a "$have_dex2oat" = "no" ]; then
562    err_echo "--bisection-search and --no-dex2oat are mutually exclusive"
563    usage="yes"
564fi
565
566if [ "$bisection_search" = "yes" -a "$have_patchoat" = "no" ]; then
567    err_echo "--bisection-search and --no-patchoat are mutually exclusive"
568    usage="yes"
569fi
570
571if [ "$usage" = "no" ]; then
572    if [ "x$1" = "x" -o "x$1" = "x-" ]; then
573        test_dir=`basename "$oldwd"`
574    else
575        test_dir="$1"
576    fi
577
578    if [ '!' -d "$test_dir" ]; then
579        td2=`echo ${test_dir}-*`
580        if [ '!' -d "$td2" ]; then
581            err_echo "${test_dir}: no such test directory"
582            usage="yes"
583        fi
584        test_dir="$td2"
585    fi
586    # Shift to get rid of the test name argument. The rest of the arguments
587    # will get passed to the test run.
588    shift
589fi
590
591# For building with javac and dx always use Java 7. The dx compiler
592# only support byte codes from Java 7 or earlier (class file major
593# version 51 or lower).
594if [ "$USE_JACK" != "true" ] && [ "$NEED_DEX" = "true" ]; then
595  export JAVAC="${JAVAC} -source 1.7 -target 1.7"
596fi
597
598if [ "$usage" = "yes" ]; then
599    prog=`basename $prog`
600    (
601        echo "usage:"
602        echo "  $prog --help                          Print this message."
603        echo "  $prog [options] [test-name]           Run test normally."
604        echo "  $prog --dev [options] [test-name]     Development mode" \
605             "(dumps to stdout)."
606        echo "  $prog --update [options] [test-name]  Update mode" \
607             "(replaces expected.txt)."
608        echo '  Omitting the test name or specifying "-" will use the' \
609             "current directory."
610        echo "  Runtime Options:"
611        echo "    -O                    Run non-debug rather than debug build (off by default)."
612        echo "    -Xcompiler-option     Pass an option to the compiler."
613        echo "    --build-option        Pass an option to the build script."
614        echo "    --runtime-option      Pass an option to the runtime."
615        echo "    --debug               Wait for a debugger to attach."
616        echo "    --debuggable          Whether to compile Java code for a debugger."
617        echo "    --gdb                 Run under gdb; incompatible with some tests."
618        echo "    --gdb-arg             Pass an option to gdb."
619        echo "    --build-only          Build test files only (off by default)."
620        echo "    --build-with-javac-dx Build test files with javac and dx (off by default)."
621        echo "    --build-with-jack     Build test files with jack and jill (on by default)."
622        echo "    --interpreter         Enable interpreter only mode (off by default)."
623        echo "    --jit                 Enable jit (off by default)."
624        echo "    --optimizing          Enable optimizing compiler (default)."
625        echo "    --no-verify           Turn off verification (on by default)."
626        echo "    --verify-soft-fail    Force soft fail verification (off by default)."
627        echo "                          Verification is enabled if neither --no-verify"
628        echo "                          nor --verify-soft-fail is specified."
629        echo "    --no-optimize         Turn off optimization (on by default)."
630        echo "    --no-precise          Turn off precise GC (on by default)."
631        echo "    --zygote              Spawn the process from the Zygote." \
632             "If used, then the"
633        echo "                          other runtime options are ignored."
634        echo "    --no-dex2oat          Run as though dex2oat was failing."
635        echo "    --no-patchoat         Run as though patchoat was failing."
636        echo "    --prebuild            Run dex2oat on the files before starting test. (default)"
637        echo "    --no-prebuild         Do not run dex2oat on the files before starting"
638        echo "                          the test."
639        echo "    --strip-dex           Strip the dex files before starting test."
640        echo "    --relocate            Force the use of relocating in the test, making"
641        echo "                          the image and oat files be relocated to a random"
642        echo "                          address before running."
643        echo "    --no-relocate         Force the use of no relocating in the test. (default)"
644        echo "    --image               Run the test using a precompiled boot image. (default)"
645        echo "    --no-image            Run the test without a precompiled boot image."
646        echo "    --host                Use the host-mode virtual machine."
647        echo "    --invoke-with         Pass --invoke-with option to runtime."
648        echo "    --dalvik              Use Dalvik (off by default)."
649        echo "    --jvm                 Use a host-local RI virtual machine."
650        echo "    --use-java-home       Use the JAVA_HOME environment variable"
651        echo "                          to find the java compiler and runtime"
652        echo "                          (if applicable) to run the test with."
653        echo "    --output-path [path]  Location where to store the build" \
654             "files."
655        echo "    --64                  Run the test in 64-bit mode"
656        echo "    --trace               Run with method tracing"
657        echo "    --strace              Run with syscall tracing from strace."
658        echo "    --stream              Run method tracing in streaming mode (requires --trace)"
659        echo "    --gcstress            Run with gc stress testing"
660        echo "    --gcverify            Run with gc verification"
661        echo "    --jvmti-stress        Run with jvmti stress testing"
662        echo "    --always-clean        Delete the test files even if the test fails."
663        echo "    --never-clean         Keep the test files even if the test succeeds."
664        echo "    --android-root [path] The path on target for the android root. (/system by default)."
665        echo "    --dex2oat-swap        Use a dex2oat swap file."
666        echo "    --instruction-set-features [string]"
667        echo "                          Set instruction-set-features for compilation."
668        echo "    --multi-image         Use a set of images compiled with dex2oat multi-image for"
669        echo "                          the boot class path."
670        echo "    --pic-test            Compile the test code position independent."
671        echo "    --quiet               Don't print anything except failure messages"
672        echo "    --bisection-search    Perform bisection bug search."
673        echo "    --vdex                Test using vdex as in input to dex2oat. Only works with --prebuild."
674        echo "    --suspend-timeout     Change thread suspend timeout ms (default 500000)."
675    ) 1>&2  # Direct to stderr so usage is not printed if --quiet is set.
676    exit 1
677fi
678
679cd "$test_dir"
680test_dir=`pwd`
681
682td_info="${test_dir}/${info}"
683td_expected="${test_dir}/${expected}"
684
685if [ ! -r $td_info ]; then
686    err_echo "${test_dir}: missing file $td_info"
687    exit 1
688fi
689
690if [ ! -r $td_expected ]; then
691    err_echo "${test_dir}: missing file $td_expected"
692    exit 1
693fi
694
695# copy the test to a temp dir and run it
696
697echo "${test_dir}: building..." 1>&2
698
699rm -rf "$tmp_dir"
700cp -Rp "$test_dir" "$tmp_dir"
701cd "$tmp_dir"
702
703if [ '!' -r "$build" ]; then
704    cp "${progdir}/etc/default-build" build
705else
706    cp "${progdir}/etc/default-build" .
707fi
708
709if [ '!' -r "$run" ]; then
710    cp "${progdir}/etc/default-run" run
711else
712    cp "${progdir}/etc/default-run" .
713fi
714
715if [ '!' -r "$check_cmd" ]; then
716    cp "${progdir}/etc/default-check" check
717else
718    cp "${progdir}/etc/default-check" .
719fi
720
721chmod 755 "$build"
722chmod 755 "$run"
723chmod 755 "$check_cmd"
724
725export TEST_NAME=`basename ${test_dir}`
726
727# Tests named '<number>-checker-*' will also have their CFGs verified with
728# Checker when compiled with Optimizing on host.
729if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
730  if [ "$runtime" = "art" -a "$image_suffix" = "" -a "$USE_JACK" = "true" ]; then
731    # In no-prebuild mode, the compiler only quickens so disable the checker.
732    if [ "$prebuild_mode" = "yes" ]; then
733      run_checker="yes"
734
735      if [ "$target_mode" = "no" ]; then
736        cfg_output_dir="$tmp_dir"
737        checker_args="--arch=${host_arch_name^^}"
738      else
739        cfg_output_dir="$DEX_LOCATION"
740        checker_args="--arch=${target_arch_name^^}"
741      fi
742
743      if [ "$debuggable" = "yes" ]; then
744        checker_args="$checker_args --debuggable"
745      fi
746
747      run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \
748                            -Xcompiler-option -j1"
749    fi
750  fi
751fi
752
753  run_args="${run_args} --testlib ${testlib}"
754
755# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and
756# ART output to approximately 128MB. This should be more than sufficient
757# for any test while still catching cases of runaway output.
758# Set a hard limit to encourage ART developers to increase the ulimit here if
759# needed to support a test case rather than resetting the limit in the run
760# script for the particular test in question.
761if ! ulimit -f 128000; then
762  err_echo "ulimit file size setting failed"
763fi
764
765good="no"
766good_build="yes"
767good_run="yes"
768if [ "$dev_mode" = "yes" ]; then
769    "./${build}" $build_args 2>&1
770    build_exit="$?"
771    echo "build exit status: $build_exit" 1>&2
772    if [ "$build_exit" = '0' ]; then
773        echo "${test_dir}: running..." 1>&2
774        "./${run}" $run_args "$@" 2>&1
775        run_exit="$?"
776
777        if [ "$run_exit" = "0" ]; then
778            if [ "$run_checker" = "yes" ]; then
779                if [ "$target_mode" = "yes" ]; then
780                  adb pull $cfg_output_dir/$cfg_output &> /dev/null
781                fi
782                "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
783                checker_exit="$?"
784                if [ "$checker_exit" = "0" ]; then
785                    good="yes"
786                fi
787                err_echo "checker exit status: $checker_exit"
788            else
789                good="yes"
790            fi
791        fi
792        echo "run exit status: $run_exit" 1>&2
793    fi
794elif [ "$update_mode" = "yes" ]; then
795    "./${build}" $build_args >"$build_output" 2>&1
796    build_exit="$?"
797    if [ "$build_exit" = '0' ]; then
798        echo "${test_dir}: running..." 1>&2
799        "./${run}" $run_args "$@" >"$output" 2>&1
800        if [ "$run_checker" = "yes" ]; then
801          if [ "$target_mode" = "yes" ]; then
802            adb pull $cfg_output_dir/$cfg_output &> /dev/null
803          fi
804          "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
805        fi
806        sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
807        good="yes"
808    else
809        cat "$build_output" 1>&${real_stderr} 1>&2
810        err_echo "build exit status: $build_exit"
811    fi
812elif [ "$build_only" = "yes" ]; then
813    good="yes"
814    "./${build}" $build_args >"$build_output" 2>&1
815    build_exit="$?"
816    if [ "$build_exit" '!=' '0' ]; then
817        cp "$build_output" "$output"
818        echo "build exit status: $build_exit" >>"$output"
819        diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
820        if [ "$?" '!=' "0" ]; then
821            good="no"
822            err_echo "BUILD FAILED For ${TEST_NAME}"
823        fi
824    fi
825    # Clean up extraneous files that are not used by tests.
826    find $tmp_dir -mindepth 1  ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
827    exit 0
828else
829    "./${build}" $build_args >"$build_output" 2>&1
830    build_exit="$?"
831    if [ "$build_exit" = '0' ]; then
832        echo "${test_dir}: running..." 1>&2
833        "./${run}" $run_args "$@" >"$output" 2>&1
834        run_exit="$?"
835        if [ "$run_exit" != "0" ]; then
836            err_echo "run exit status: $run_exit"
837            good_run="no"
838        elif [ "$run_checker" = "yes" ]; then
839            if [ "$target_mode" = "yes" ]; then
840              adb pull $cfg_output_dir/$cfg_output &> /dev/null
841            fi
842            "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
843            checker_exit="$?"
844            if [ "$checker_exit" != "0" ]; then
845                err_echo "checker exit status: $checker_exit"
846                good_run="no"
847            else
848                good_run="yes"
849            fi
850        else
851            good_run="yes"
852        fi
853    else
854        good_build="no"
855        cp "$build_output" "$output"
856        echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
857        echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
858        echo "Args: ${args}" >> "$output"
859        echo "build exit status: $build_exit" >> "$output"
860        max_name_length=$(getconf NAME_MAX ${tmp_dir})
861        echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
862        max_path_length=$(getconf PATH_MAX ${tmp_dir})
863        echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
864    fi
865    ./$check_cmd "$expected" "$output"
866    if [ "$?" = "0" ]; then
867        if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
868          # output == expected
869          good="yes"
870          echo "${test_dir}: succeeded!" 1>&2
871        fi
872    fi
873fi
874
875(
876    if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
877        echo "${test_dir}: FAILED!"
878        echo ' '
879        echo '#################### info'
880        cat "${td_info}" | sed 's/^/# /g'
881        echo '#################### diffs'
882        diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000
883        echo '####################'
884        if [ "$strace" = "yes" ]; then
885            echo '#################### strace output'
886            tail -n 3000 "$tmp_dir/$strace_output"
887            echo '####################'
888        fi
889        echo ' '
890    fi
891
892) 2>&${real_stderr} 1>&2
893
894# Attempt bisection only if the test failed.
895if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then
896    # Bisecting works by skipping different optimization passes which breaks checker assertions.
897    if [ "$run_checker" == "yes" ]; then
898      echo "${test_dir}: not bisecting, checker test." 1>&2
899    else
900      # Increase file size limit, bisection search can generate large logfiles.
901      echo "${test_dir}: bisecting..." 1>&2
902      cwd=`pwd`
903      maybe_device_mode=""
904      raw_cmd=""
905      if [ "$target_mode" = "yes" ]; then
906        # Produce cmdline.sh in $DEX_LOCATION. "$@" is passed as a runtime option
907        # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set
908        # to exec in order to preserve pid when calling dalvikvm. This is required
909        # for bisection search to correctly retrieve logs from device.
910        "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null
911        adb shell chmod u+x "$DEX_LOCATION/cmdline.sh"
912        maybe_device_mode="--device"
913        raw_cmd="$DEX_LOCATION/cmdline.sh"
914      else
915        raw_cmd="$cwd/${run} --external-log-tags $run_args $@"
916      fi
917      $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \
918        $maybe_device_mode \
919        --raw-cmd="$raw_cmd" \
920        --check-script="$cwd/check" \
921        --expected-output="$cwd/expected.txt" \
922        --logfile="$cwd/bisection_log.txt" \
923        --timeout=300
924    fi
925fi
926
927# Clean up test files.
928if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
929    cd "$oldwd"
930    rm -rf "$tmp_dir"
931    if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
932        adb shell rm -rf $DEX_LOCATION
933    fi
934    if [ "$good" = "yes" ]; then
935        exit 0
936    fi
937fi
938
939
940(
941    if [ "$always_clean" = "yes" ]; then
942        echo "${TEST_NAME} files deleted from host "
943        if [ "$target_mode" == "yes" ]; then
944            echo "and from target"
945        fi
946    else
947        echo "${TEST_NAME} files left in ${tmp_dir} on host"
948        if [ "$target_mode" == "yes" ]; then
949            echo "and in ${DEX_LOCATION} on target"
950        fi
951    fi
952
953) 2>&${real_stderr} 1>&2
954
955if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
956  exit 0
957else
958  exit 1
959fi
960